--[[ osk selector ]]--

function PluginFunc(editor, editctrl)
  local ef
  local Dir = "/osk"

  while true do
    local FileList = {}
    local PluginNameList = {}
    if editor.OnWindows then
      FileList = { {}, {} }
    else
      FileList = System.listDirectory(editor.BaseDir .. Dir)
    end

    -- remove "." and ".."
    table.remove(FileList, 1)
    table.remove(FileList, 1)
    table.sort(FileList,
      function(a, b)
        if a.directory == b.directory then return a.name < b.name end
        return b.directory
      end
    )

    for idx,file in FileList do
      if file.directory then
        table.insert(PluginNameList, "/" .. file.name)
      else
        local ul  = string.find(file.name, "_") or 0
        local dot = string.find(file.name, "%.[^.]*$") or 0
        table.insert(PluginNameList, string.sub(file.name, ul+1, dot-1))
      end
    end

    local Sel = editor:MenuMain(PluginNameList, "Select OSK")
    if not Sel then return end

    if FileList[Sel].directory then
      Dir = Dir .. PluginNameList[Sel]
    else
      local fln = editor.BaseDir .. Dir .. "/" .. FileList[Sel].name
      local func, err = loadfile(fln)
      if not func then
        editor:EditOneLine("Compile error", 40, err)
      else
        dofile(fln)
      end
      return
    end
  end
end